/* cold-spare guard: 2 primary units P1 and P2, 1 shared spare A1, 1 dedicated spare A2 for P1 */
FactorModel {
  O1 desc "CSP gate output"
    requiresNOf(1|A2,H1) requiresOcc(P1) final mishap;
  O2 desc "CSP gate output"
    requiresNOf(1|A1,H2) requiresOcc(P2) final mishap;
  H1 requiresMit(P2) final; // signal that spare is occupied
  H2 requiresMit(P1) final;
  P1 desc "primary unit 1 fails"
    mitPreventsMit(P2); // shared spare A1 can only be used once
  P2 desc "primary unit 2 fails"
    mitPreventsMit(P1,A1); // because A2 is only spare for P1
  A1 desc "shared alternate unit 1 fails"
    requiresNOf(1|H1,H2) preventsMit(P1,P2); 
  A2 desc "alternate unit 2 (dedicated to P1) fails"
    requiresMit(A1) // because trigger for spare A2
    requiresNot(P2) // because A1 is not used for P2
    requiresOcc(P1) // P1 failed or even mitigated
    preventsMit(A1) // failure of A1 prevents mitigation of A1
    final;
}

Settings {
  suppressResumptions=true;
  graphDirection=LR;
}
