Activity {
  include moving;
  successor welding;
  successor idle;
}

FactorModel {
  // latent causes
  HRW desc "(H)uman arm and (R)obot on shared (W)orkbench"
    prevents (HC)
    mitPreventsMit (HS,HC)
    guard "hACT_WORKING & rloc=sharedTbl & hloc=sharedTbl"
    detectedBy (SHARE.HRWdet)
    mitigatedBy (PREVENT.HRWmit)
    resumedBy (.HRWres)
    mis=h_placeWorkpieceLeft|h_grabRightWorkpiece
    prob=0.01
    sev=3;
  HC // extends (moving::*).HC by
    prevents (HRW)
    mitPreventsMit (HRW);
}

Application cobot {
  // detectors
  mode RCdet desc "touch sensor"
    guard "hACT_WORKING";
  mode RTdet
    prob=0.5;

  // mitigation and resumption actions
  mode HRWdet 
    guard "hACT_WORKING & rloc=sharedTbl & lgtBar=true"
    embodiedBy cellObSys;
  mode HRWmit desc "safety-rated monitored stop in current activity"
    update "(notif_leaveWrkb'=true)" // application of safety function
    target (safmod=srmst) // mitigation to safety mode
    embodiedBy robotArm
    disruption=5 nuisance=1 effort=0.5;
  mode HRWres
    guard "hloc!=sharedTbl" // checking for safety function deployment and hazard removal
    update "(notif_leaveWrkb'=false)" // switching off safety function
    target (safmod=normal); // resumption to less restrictive safety mode

  mode HWdet 
    guard "hACT_WORKING & lgtBar=true"
    embodiedBy lgtBar;
  mode HWmit desc "speed/separation monitoring" type LIMIT
    target (safmod=ssmon)
    disruption=1 effort=2;
  mode HWres desc "speed/separation monitoring"
    target (safmod=normal); // target if no other critical event is active
}
