Settings{
  extFile = cobot23-tpl.prism;
}

Activity {}

Application cobot {
  // reused formulas
  hST_HOinSGA = "hloc=inCell | hloc=atWeldSpot";
  hACT_WELDING = "ract=welding & wact=welding";
  hST_HOatShTbl = "hloc=sharedTbl";
  hSM_PERM = "safmod=normal | safmod=srmst | safmod=hguid | safmod=ssmon | safmod=pflim";
  hFINAL_CUSTOM = "wpfin & wps=empty & !reffocc & mntDone";

  mode rngDet;
  
  // behaviour embodying loop components
  safetyCtr type CONTROLLER
    notif="[ok..resetCtr] init ok" 
    notif_leaveWrkb="bool init false";
  humanOp type HUMAN_OPERATOR;
  robotArm type AGENT
    validActs="exchWrkp|welding|off";
  weldingMachine type AGENT
    validActs="welding|idle|off";

  // physical components
  cellObSys desc "cell observation system" role OPTICAL;
  rngDet desc "range detector" role OPTICAL partOf cellObSys;
  lgtBar desc "light barrier" partOf cellObSys;
  srmst_dev role ACTUATOR partOf robotArm;
}

// risk gradient matrices for activities and safety modes (skew-diagonal, relative distances)
Distances act {
 off:       0;
 idle:      1 0; 
 exchWrkp:  3 2 0;
 welding:   5 4 2 0;
}
         
Distances safmod {
 normal:   0;
 hguid:   -2  0;
 ssmon:   -1  1    0;
 pflim:   -2  0   -1  0;
 srmst:   -3 -1   -2 -1  0;
 stopped: -4 -2   -3 -2 -1  0;
}

Weights rewards {
                         guard             prod   eff_plant_time; 
  // robotArm
 r_moveToTable:          ""                "h"    "2*macro";
 r_grabLeftWorkpiece: 	 ""                "m"    "macro"  ;
 r_placeWorkpieceRight:  ""                "h"    "macro"  ;
 r_moveToWelder: 	       ""                "h"    "2*macro";
  // robotArm and weldingMachine
 rw_weldStep: 		       ""                "h"    "3*macro"; 
 rw_leaveWelder: 	       ""                "h"    "macro"  ;
  // humanOp
 h_start: 		           ""                "l"    "macro"  ;
 h_placeWorkpieceLeft: 	 ""                "h"    "2*macro";
 h_withDrawArm: 	       ""                "l"    "macro"  ;
 h_grabRightWorkpiece:   ""                "h"    "macro"  ;
 h_enterCell:		         ""                "none" "none"   ;
 h_approachWeldSpot: 	   ""                "h"    "2*macro";  
 h_exitPlant: 		       "notif=leaveArea" "none" "none";
}
