Activity {
  include moving;
  successor exchWrkp; 
  successor off;      
  successor idle;     
}

FactorModel {
  // accidents
  WS desc "(W)elding (S)parks cause operator injuries"
    mishap
    requiresNOf (1|HC,HS)
    guard "hACT_WELDING"
    detectedBy (SHARE.WSdet)
    mitigatedBy (.WSmit)
    resumedBy (.WSres)
    mis="h_approachWeldSpot"
    prob=0.01
    sev=5;
}

Application cobot {
  // detectors, mitigation and resumption commands ...
  // ... for WS
  mode WSdet desc "image processing"
    guard "hACT_WELDING";

  mode WSmit
    event WSstop
    target (act=idle, safmod=srmst) // not needed because WSp=mis=deadlock
    disruption=5 effort=1;
  mode WSres // not needed because WSp=mis=deadlock
    event WSres
    guard "!hST_HOinSGA"
    target (act=welding, safmod=normal);
}

Weights rewards {
                         guard             risk_WS;
  // robotArm
 r_moveToTable:          ""                "5";
 r_grabLeftWorkpiece: 	 ""                "1";
 r_placeWorkpieceRight:  ""                "1";
 r_moveToWelder: 	       ""                "5";
  // robotArm and weldingMachine
 rw_weldStep: 		       ""                "10"; 
 rw_leaveWelder: 	       ""                "5";
  // humanOp
 h_start: 		           ""                "0";
 h_placeWorkpieceLeft: 	 ""                "0";
 h_withDrawArm: 	       ""                "0";
 h_grabRightWorkpiece:   ""                "0";
 h_enterCell:		         ""                "5";
 h_approachWeldSpot: 	   ""                "7"; 
 h_exitPlant: 		       "notif=leaveArea" "0";
}
